public class Frame
{
    private int    ball1;
    private int    ball2;
    private Frame nextFrame;

    public Frame()
    {
        ball1 = -1;
        ball2 = -1;
        nextFrame = null;
    }

    public void roll( int ball )
    {
        if ( ball1 == -1 )
            ball1 = ball;
        else if ( ball1 != 10 && ball2 == -1 )
            ball2 = ball;
        else
        {
            if ( nextFrame == null )
                nextFrame = new Frame();
            nextFrame.roll( ball );
        }
    }

    public int score()
    {
        if ( ball1 == 10 )
            return 10 + nextFrame.firstBall() + nextFrame.secondBall();

        int total = ball1 + ball2;
        if ( total == 10 )
            return 10 + nextFrame.firstBall();

        return ball1 + ball2;
    }

    public int gameScore()
    {
        return gameScore( 1 );
    }

    private int gameScore( int frameNumber )
    {
        if (( nextFrame == null ) || ( frameNumber == 10 ))
            return score();
        return score() + nextFrame.gameScore( frameNumber + 1 );
    }

    private int firstBall()
    {
        return ball1;
    }

    private int secondBall()
    {
        if ( ball2 == -1 )
            return nextFrame.firstBall();
        return ball2;
    }
}
