import junit.framework.*;

public class StrikeFrameTest extends TestCase
{
    private Frame strikeFrame;

    protected void setUp()
    {
        strikeFrame = new Frame();
        strikeFrame.roll( 10 );
        strikeFrame.roll( 2 );
        strikeFrame.roll( 3 );
    }

    public void testSingleStrike()
    {
        assertEquals( 15, strikeFrame.score() );
    }

    public void testTwoStrikes()
    {
        strikeFrame = new Frame();
        strikeFrame.roll( 10 );
        strikeFrame.roll( 10 );
        strikeFrame.roll( 2 );
        strikeFrame.roll( 3 );
        assertEquals( 22, strikeFrame.score() );
    }

    public void testSingleStrikeAll()
    {
        assertEquals( 20, strikeFrame.gameScore() );
    }

    public void testSeveralSpares()
    {
        for ( int i = 0; i < 4; i++ )
        {
            strikeFrame.roll( 10 );
            strikeFrame.roll( 5 );
            strikeFrame.roll( 4 );
        }
        assertEquals( 132, strikeFrame.gameScore() );
    }

    public void testStrikeInLastFrame()
    {
        Frame spareFrame = new Frame();
        for ( int i = 0; i < 18; i++ )
            spareFrame.roll( 0 );

        spareFrame.roll( 10 );
        spareFrame.roll( 10 );
        spareFrame.roll( 9 );
        assertEquals( 29, spareFrame.gameScore() );
    }

    public void testAllStrikes()
    {
        Frame frame = new Frame();
        for ( int i = 0; i < 12; i++ )
            frame.roll( 10 );
        assertEquals( 300, frame.gameScore() );
    }

    public static Test suite()
    {
        return new TestSuite( StrikeFrameTest.class );
    }

    public static void main( String[] args )
    {
        junit.textui.TestRunner.run( suite() );
    }
}
